function J=jetm(cmin,cmax,czero,nc)
%jetm(cmin,cmax,czero,nc)	Variant of jet
%	Allows the jet colormap to be off-centre
% 	cmin, cmax are max and min values used in caxis
%	czero is the value to be at the centre
%	nc is the length of colormap to be generated (optional)

if nargin < 4, nc = size(get(gcf,'colormap'),1); end

cmin=-10;
cmax=20;
czero=0;
nc=100

zeron=round((czero-cmin)/(cmax-cmin)*nc);

a1=round(zeron/4)
a2=round(zeron*3/4)

b1=a2
b2=round(zeron+(nc-zeron)/4)

c1=b2
c2=round(zeron+(nc-zeron)*3/4)

x=(1:nc)/nc;

a=0;
a(1:a1)=0.5+0.5*x(1:a1)/(a1/nc);
a(a1:a2)=ones(size(a1:a2));
a(a2:zeron)=1-(x(a2:zeron)-(a2/nc))/((zeron-a2)/nc);
a(zeron:nc)=zeros(size(zeron:nc));

b=0;
b(1:a1)=zeros(size(1:a1));
b(a1:b1)=(x(a1:b1)-a1/nc)/((b1-a1)/nc);
b(b1:b2)=ones(size(b1:b2));
b(b2:c2)=1-(x(b2:c2)-(b2/nc))/((c2-b2)/nc);
b(c2:nc)=zeros(size(c2:nc));

c=0;
c(1:zeron)=zeros(size(1:zeron));
c(zeron:c1)=(x(zeron:c1)-zeron/nc)/((c1-zeron)/nc);
c(c1:c2)=ones(size(c1:c2));
c(c2:nc)=1-0.5*(x(c2:nc)-c2/nc)/((nc-c2)/nc);

J=[a' b' c'];