C vr=munfold(v, range, elev, xr, zr)
      subroutine mexfunction(nlhs, plhs, nrhs, prhs)

      integer*4 nlhs, nrhs
      integer*4 plhs(*), prhs(*)

      integer*4 m_in, n_in, nx, nz
      integer*4 vp, vrp, rangep, elevp, xrp, zrp

      m_in = mxgetm(prhs(1))
      n_in = mxgetn(prhs(1))

      nx = mxgetn(prhs(4))
      nz = mxgetn(prhs(5))
      
      vp = mxgetpr(prhs(1))
      rangep = mxgetpr(prhs(2))
      elevp = mxgetpr(prhs(3))
      xrp = mxgetpr(prhs(4))
      zrp = mxgetpr(prhs(5))

      plhs(1) = mxcreatefull(nx, nz, 0)
      
      vrp = mxgetpr(plhs(1))

      call minterp(%VAL(vrp), %VAL(vp), %VAL(rangep), %VAL(elevp),
     : %VAL(xrp), %VAL(zrp), m_in, n_in, nx, nz)

      return
      end

C================main munfold subroutine=========================
      
      SUBROUTINE minterp(vr, v, range, elev, xr, zr, mm, nn, nx, nz)
      IMPLICIT NONE
      integer*4 mm, nn, M, N, nx, nz
      integer*4 i, j

      PARAMETER (M=310, N=1100)
      real*8 vr(nx, nz), v(mm, nn), range(mm), elev(nn),xr(nx),zr(nz)
      real pi, xp, zp, maxelev, d1, d2, d3, d4, vel1, vel2, vel3, vel4
      real*8 X(M,N), Z(M,N), nan, r, el
      integer scandir, topj, rowsleft, m1, m2, m3, m4, n1, n2, n3, n4

      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN

      IF ((mm.LE.M).AND.(nn.LE.N)) THEN

         nan=mexGetNan()
         pi=3.142

         DO i=1,mm
            DO j=1, nn
               X(i,j)=range(i)*COS(elev(j)*pi/180.0)
               Z(i,j)=range(i)*SIN(elev(j)*pi/180.0)
C     correction - basically as on Chilbolton web pages
C     and therefore in Battan
C     Z=Z+3*X.^2/(8*6371);
               Z(i,j)=Z(i,j)+(3.0*X(i,j)**2)/(8.0*6371)
            ENDDO
         ENDDO

         IF (elev(nn).GT.elev(1)) THEN
            scandir=1
            maxelev=elev(nn)
            topj=nn
C     print*, 'going up'     !error here somewhere
         ELSE
            scandir=-1
            maxelev=elev(1)
            topj=1
C     print*, 'going down'
         ENDIF

         DO j=1,nz
            rowsleft=nz-j
            do i=1,nx
               vr(i,j)=nan
               xp=xr(i)
               zp=zr(j)
               r=(xp**2.0 + zp**2.0) ** 0.5
               el=ATAN2(zp,xp)*180/pi

               IF (el.LE.maxelev) THEN
                  
                  m1=mm
                  DO WHILE ((range(m1).GE.r).AND.(m1.GT.1))
                     m1=m1-1
                  ENDDO

                  n1=topj
C     print*, el, topj, nn, scandir
C     print*, elev
                  DO WHILE ((n1.LE.nn).AND.(n1.GE.1).AND
     $                 .(elev(n1).GE.el))
                     n1=n1-scandir
C     print*, n1
                  ENDDO

                  m2=m1+1
                  m3=m1+1
                  m4=m1
                  
                  n2=n1
                  n3=n1+scandir
                  n4=n1+scandir

                  IF ((m1.GE.1).AND.(m2.LE.mm).AND.(n1.GE.1).AND.
     :                 (n3.GE.1).AND.(n1.LE.nn).AND.(n3.LE.nn)) THEN

                     d1=((xp-X(m1,n1))**2.0+(zp-Z(m1,n1))**2.0)**(-0.5
     $                    )
                     d2=((xp-X(m2,n2))**2.0+(zp-Z(m2,n2))**2.0)**(-0.5
     $                    )
                     d3=((xp-X(m3,n3))**2.0+(zp-Z(m3,n3))**2.0)**(-0.5
     $                    )
                     d4=((xp-X(m4,n4))**2.0+(zp-Z(m4,n4))**2.0)**(-0.5
     $                    )
                     vel1=v(m1,n1)
                     vel2=v(m2,n2)
                     vel3=v(m3,n3)
                     vel4=v(m4,n4)

                     vr(i,j)=(d1*vel1+d2*vel2+d3*vel3+d4*vel4)/
     :                    (d1+d2+d3+d4)
                  ENDIF
               ENDIF

            ENDDO     
         ENDDO       

      ELSE                      !mm and/or nn too big

         PRINT*, "input matrix is too large. mm, nn="
         PRINT*, mm,nn
         PRINT*, "M, N="
         PRINT*, M,N
         DO i=1,mm
            DO j=1,nn
               vr(i,j)=v(i,j)
            ENDDO
         ENDDO
         
      ENDIF
      
      RETURN
      END
