C vel=munfill(v)
C Unfolds data by flood-filling regions, unfolding as it goes...
C Needs to be given well-zapped data...

      subroutine mexfunction(nlhs, plhs, nrhs, prhs)

      integer*4 nlhs, nrhs
      integer*4 plhs(*), prhs(*)

      integer*4 m_in, n_in
      integer*4 vp, velp, regp

      m_in = mxgetm(prhs(1))
      n_in = mxgetn(prhs(1))
      
      vp = mxgetpr(prhs(1))

      plhs(1) = mxcreatefull(m_in, n_in, 0)
      plhs(2) = mxcreatefull(m_in, n_in, 0)
      
      velp = mxgetpr(plhs(1))
      regp = mxgetpr(plhs(2))

      call munfill(%VAL(velp),%VAL(regp), %VAL(vp), m_in, n_in)
      
      return
      end

C==============main munfill subroutine==========================
C [mm,nn] is the size of the arrays vel, region and v_orig

      subroutine munfill(vel,region,v_orig,mm,nn)
      IMPLICIT NONE
      integer*4 mm, nn, M, N
      PARAMETER (M=400, N=1600)

      integer*4 i, j,ii,jj,k,l,o,p,stacki(M*N), stackj(M*N), numreg(M
     $     *N),mask(M,N),reg,nor,mink,minl
      integer*4 stackindex, goon, flagup1, flagdown1,region_num,
     $     stacksize, stackreg(M*N), max_reg

      real*8 vel(mm, nn), v_orig(mm, nn), region(mm,nn),v(M,N),av


      real*8 nan
      real*8 vf,dist_min,dist,change,maxvar,lonely1
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      IF ((mm.LE.M).AND.(nn.LE.N)) THEN
      
C     unfolds by filling in regions...

C     first zap the data

         maxvar=4.0
         lonely1=5.0
         vf=30
         
         CALL mzap(vel,v_orig,maxvar,lonely1,0.0,mm,nn)

C and reduce the complexity by removing small regions...

         if (nn.gt.300) then
            print*,'reducing...'
            CALL reduce(vel,10,mm,nn)
            print*, '...done. Now unfolding regions...'
         endif

C Start the calculation...
         DO i=1,mm
            DO j=1,nn
               v(i,j)=vel(i,j)
               vel(i,j)=v(i,j)
               mask(i,j)=0      ! haven't unfolded yet
               region(i,j)=0    ! this will be the default undefined region
            ENDDO
         ENDDO

         region_num=1

        DO i=1,mm
            DO j=1,nn
               IF (mexIsNaN(v(i,j)).EQ.0) THEN
                  GOTO 10
               ENDIF
            ENDDO
         ENDDO
         
C     Found our starting point...
C     Loop below jumps up to this point after finding a starting i and
c     j...
 10      stackindex=1
         stacki(stackindex)=i
         stackj(stackindex)=j

         DO WHILE (stackindex.GT.0)
	
            i=stacki(stackindex)
            j=stackj(stackindex)

 
            stackindex=stackindex-1
	
C     Check to see if this line has already been done

C            print*, i,j,mexIsNaN(v(i,j))
            IF (mexIsNaN(v(i,j)).EQ.0) THEN

C     let's do it...
C     first move to the beginning of the line
C     but... we need to unfold as we go... this difference is that
c     here we don't set v to NaN, so when we reach the end, we come 
c     back
	
               call unf(vel,mask,region,region_num,i,j,mm,nn,M,N)
               mask(i,j)=1
               region(i,j)=region_num

               goon=1
               DO WHILE ((i .GT. 1).AND.(goon.EQ.1))
                  IF (mexIsNaN(v(i-1,j)).EQ.0) THEN  
                     i=i-1
                     call unf(vel,mask,region,region_num,i,j,mm,nn,M,N)
                     mask(i,j)=1
                     region(i,j)=region_num
                  else
                     goon=0
                  endif
               enddo
		
C     mark this location

               v(i,j)=nan
               call unf(vel,mask,region,region_num,i,j,mm,nn,M,N)
               mask(i,j)=1
               region(i,j)=region_num

               flagup1=1        ! "fix" the flags for previous nans...
               flagdown1=1      ! 1=NaN, 0=clear
		
               goon=1
		
C     move along...
               do while ((i .lt. mm).and.(goon.eq.1))
C     check if clear above...
                  if (j .lt. nn) then 
                     if ((mexIsNaN(v(i,j+1)).EQ.0).and.(flagup1.eq.1))
     $                    then
                        stackindex=stackindex+1
                        stacki(stackindex)=i
                        stackj(stackindex)=j+1
                     endif
                     flagup1=mexIsNaN(v(i,j+1))
                  endif
                  if (j .gt. 1) then 
                     if ((mexisnan(v(i,j-1)).eq.0).and.(flagdown1.eq.1
     $                    )) then
                        stackindex=stackindex+1
                        stacki(stackindex)=i
                        stackj(stackindex)=j-1
                     endif
                     flagdown1=mexisnan(v(i,j-1))
                  endif
			
                  if (mexisnan(v(i+1,j)).eq.0) then
                     i=i+1
                     call unf(vel,mask,region,region_num,i,j,mm,nn,M,N)
                     mask(i,j)=1
                     v(i,j)=NaN
                     region(i,j)=region_num
                  else
                     goon = 0
                  endif
		
               enddo

            endif
		
         enddo
C     Check for any more regions containing data

         DO i=1,mm
            DO j=1,nn
               IF (mexIsNaN(v(i,j)).EQ.0) THEN
                  region_num=region_num+1
                  GOTO 10
               ENDIF
            ENDDO
         ENDDO
             
         nor=region_num ! number of regions
         print*, 'Number of regions: ',nor
C     At this point, we should have unfolded all the individual
c     regions, and worked out in which region each point lies. Now we
c     want to combine regions together... Start with region one, and
c     merge it with the clostest region... repeat until we just have
c     one region left.

C     Count the region sizes...

         do i=1,nor
            numreg(i)=0
         enddo
         
         DO i=1,mm
            DO j=1,nn
               if (region(i,j).ne.0) then
                  numreg(region(i,j))=numreg(region(i,j))+1
               endif
            enddo
         enddo

C Get rid of really small pathetic regions...

         if (nn.gt.400) then
            max_reg=0
            do k=1,nor
               if (numreg(k).gt.max_reg) then
                  max_reg=numreg(k)
               endif
            enddo
            max_reg=max_reg/400
         else
            max_reg=6
         endif
         
         goon=0
         do k=1,nor
            if (numreg(k).le.max_reg) then
               do i=1,mm
                  do j=1,nn
                     if (region(i,j).eq.k) then
                        vel(i,j)=nan
                        region(i,j)=0
                     endif
                  enddo
               enddo
               numreg(k)=0
               goon=goon+1
            endif
         enddo

         print*,'After further reduction, ',nor-goon
     $        ,' regions remaining'


C     Have it so that we output the regions too - note we don't need
c     mask any more so we can overwrite and use it
C     Also, when we start looking for nearest points, we only want to look
c     at points on boundaries (as interior points will never be
c     closest), so calculate these locations in advance

         stackindex=0
         do i=2,mm-1
            do j=2,nn-1
               mask(i,j)=region(i,j)
               if (mexisnan(vel(i,j)).eq.0) then
                  k=(mexisnan(vel(i-1,j+1)).eq.1)+(mexisnan(vel(i,j+1)
     $                 ).eq.1)+(mexisnan(vel(i+1,j+1)).eq.1)
     $                 +(mexisnan(vel(i-1,j)).eq.1)+(mexisnan(vel(i+1
     $                 ,j)).eq.1)+(mexisnan(vel(i-1,j-1)).eq.1)
     $                 +(mexisnan(vel(i,j-1)).eq.1)+(mexisnan(vel(i+1
     $                 ,j-1)).eq.1)
                  if (k.gt.0) then
                     stackindex=stackindex+1
                     stacki(stackindex)=i
                     stackj(stackindex)=j
                     stackreg(stackindex)=region(i,j)
                  endif
               endif
            enddo
         enddo
         stacksize=stackindex

C     find the closest region to the region which contains the most
c     points (see above)...
         max_reg=0
         do k=1,nor
            if (numreg(k).gt.max_reg) then
               max_reg=numreg(k)
               region_num=k
            endif
         enddo

         print*, 'Main Region: ',region_num,'  Points: '
     $        ,numreg(region_num)
c$$$         region_num=-1
c$$$         do o=1,nor
c$$$            if (numreg(o).gt.0) then
c$$$               region_num=o
c$$$               goto 40
c$$$            endif
c$$$         enddo
C 40      print*, region_num

         do o=1,nor-1
            if (numreg(o).gt.0) then
               dist_min=1E10
               mink=0
               minl=0
               do k=1,stacksize
                  if (stackreg(k).ne.region_num) then
                     do l=1,stacksize
                        if (stackreg(l).eq.region_num) then
                           dist=(stacki(k)-stacki(l))**2.0+(stackj(k)
     $                          -stackj(l))**2.0
                           if (dist.lt.dist_min) then
                              dist_min=dist
                              mink=k
                              minl=l
                              if (dist.lt.5) then
                                 goto 50
                              endif
                           endif
                        endif
                     enddo
                  endif
               enddo
C               print*,mink
 50            if (mink.gt.0) then
                  i=stacki(mink) ! this is the one we're going to change
                  j=stackj(mink)
                  ii=stacki(minl) ! this is the one that is in region 1
                  jj=stackj(minl)
                  reg=stackreg(mink)
                  print*,'Number: ',o,'   Region: ',reg,'  Points: ',
     $                 numreg(stackreg(mink))
C     print*,'============================================'
C     print*,i,j,ii,jj
C     print*,dist_min,reg
C     Now we should have found the point closest to ii,jj, so work out
c     what velocity fold the new region needs...
                  if ((vel(i,j)-vel(ii,jj)).gt.(2.5*vf)) then
                     change=-3.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(1.5*vf)) then
                     change=-2.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(0.5*vf)) then
                     change=-1.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(-0.5*vf)) then
                     change=-0.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(-1.5*vf)) then
                     change=1.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(-2.5*vf)) then
                     change=2.0*vf
                  elseif ((vel(i,j)-vel(ii,jj)).gt.(-3.5*vf)) then
                     change=3.0*vf
                  endif
C                  print*,reg
C                  print*,'vel(i,i)=',vel(i,j),'at',i,j
C                  print*,'vel(ii,jj)=',vel(ii,jj),'at',ii,jj
C                  print*,'change=',change
C     Now add change to all the points in this second region, and
c     change the region array so that it is equal to region_num  
                  
                  DO i=1,mm
                     DO j=1,nn
                        if (mask(i,j).eq.reg) then
                           vel(i,j)=vel(i,j)+change
                           mask(i,j)=1
                        endif
                     enddo
                  enddo
                  
                  do p=1,stacksize
                     if (stackreg(p).eq.reg) then
                        stackreg(p)=region_num
                     endif
                  enddo
               endif      
            endif
         enddo 
            
C     now we've unfolded all the good data - use this as a "mask" to
c     unfold everything else too (in case we chopped out some good
c     data)
         print*, 'calling replace...'
         CALL replace(vel,mm,nn)
         print*,'...done replace'

C     now treat vel as just a mask for the original velocity
c     array - ie fold the original to get it as close as
c     possible to the mask
         
         do j=1,nn
            do i=1,mm
               
               av=vel(i,j)
               vel(i,j)=v_orig(i,j)
               if ((vel(i,j)-av).gt.(2.5*vf)) then
                  vel(i,j)=vel(i,j)-3.0*vf
               elseif ((vel(i,j)-av).gt.(1.5*vf)) then
                  vel(i,j)=vel(i,j)-2.0*vf
               elseif ((vel(i,j)-av).gt.(0.5*vf)) then
                  vel(i,j)=vel(i,j)-1.0*vf
               elseif ((vel(i,j)-av).gt.(-0.5*vf)) then
                  vel(i,j)=vel(i,j)-0.0*vf
               elseif ((vel(i,j)-av).gt.(-1.5*vf)) then
                  vel(i,j)=vel(i,j)+1.0*vf
               elseif ((vel(i,j)-av).gt.(-2.5*vf)) then
                  vel(i,j)=vel(i,j)+2.0*vf
               elseif ((vel(i,j)-av).gt.(-3.5*vf)) then
                  vel(i,j)=vel(i,j)+3.0*vf
               endif
               
            enddo
         enddo
         print*,'Finished running munfill'
         
      ELSE                      !mm and/or nn too big
         
         PRINT*, "input matrix is too large. mm, nn="
         PRINT*, mm,nn
         PRINT*, "M, N="
         PRINT*, M,N
         DO i=1,mm
            DO j=1,nn
               vel(i,j)=v(i,j)
            ENDDO
         ENDDO
         
      ENDIF
      
 
      return
      end

C====================================================================

      subroutine unf(vel,mask,region,region_num,i,j,mm,nn,M,N)
      IMPLICIT NONE
      integer*4 mm, nn,M,N

      integer*4 i, j, ii,jj, region_num,mask(M,N), count

      real*8 vel(mm, nn),region(mm,nn)

      real*8 total,av
      real*8 vf
      
      vf=30

C     work out the average of the valid (i.e. already unfolded)
c     velocities

      count=0
      total=0.0

      ii=i-1
      jj=j+1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i
      jj=j+1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i+1
      jj=j+1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i+1
      jj=j
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i+1
      jj=j-1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i
      jj=j-1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i-1
      jj=j-1
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif
      ii=i-1
      jj=j
      if ((ii.GE.1).AND.(ii.LE.mm).AND.(jj.GE.1).AND.(jj.LE.nn).AND
     $     .(region(ii,jj).EQ.region_num)) then
         total=total+mask(ii,jj)*vel(ii,jj)
         count=count+mask(ii,jj)
      endif

c$$$      print*, '-----------------------------------------'
c$$$      print*, vel(i-1,j+1),vel(i,j+1),vel(i+1,j+1)
c$$$      print*, vel(i-1,j),vel(i,j),vel(i+1,j)
c$$$      print*, vel(i-1,j-1),vel(i,j-1),vel(i+1,j-1)
c$$$
c$$$      print*, ' '
c$$$      print*, mask(i-1,j+1),mask(i,j+1),mask(i+1,j+1)
c$$$      print*, mask(i-1,j),mask(i,j),mask(i+1,j)
c$$$      print*, mask(i-1,j-1),mask(i,j-1),mask(i+1,j-1)

      if (count.gt.0) then
         av=total/count
         if ((vel(i,j)-av).gt.(2.5*vf)) then
            vel(i,j)=vel(i,j)-3.0*vf
         elseif ((vel(i,j)-av).gt.(1.5*vf)) then
            vel(i,j)=vel(i,j)-2.0*vf
         elseif ((vel(i,j)-av).gt.(0.5*vf)) then
            vel(i,j)=vel(i,j)-1.0*vf
         elseif ((vel(i,j)-av).gt.(-0.5*vf)) then
            vel(i,j)=vel(i,j)-0.0*vf
         elseif ((vel(i,j)-av).gt.(-1.5*vf)) then
            vel(i,j)=vel(i,j)+1.0*vf
         elseif ((vel(i,j)-av).gt.(-2.5*vf)) then
            vel(i,j)=vel(i,j)+2.0*vf
         elseif ((vel(i,j)-av).gt.(-3.5*vf)) then
            vel(i,j)=vel(i,j)+3.0*vf
         endif
      endif ! otherwise just leave vel alone

C      print*, av, vel(i,j)

      return
      end



C=============================================================
C================main mzap subroutine=========================
C=============================================================
C Note vel has fixed dimensions - M,N have to be same as above
      
      subroutine mzap(vel, v, maxvar, lonely1, lonely2, mm, nn)
      IMPLICIT NONE
      integer*4 mm, nn, M, N
      integer*4 i, j, k

      PARAMETER (M=400, N=1600)
      real*8 maxvar, lonely1, lonely2
      real*8 vel(mm,nn), v(mm, nn)

      real*8 mv2, var(M,N), nan
      integer mask1(M,N)
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      mv2=maxvar**2.0

C work out the variance matrix

      DO i=2,mm-1
         DO j=2,nn-1
            var(i,j)=(((v(i,j-1)-v(i,j))**2)+((v(i,j-1)-v(i,j))**2)+
     :((v(i+1,j-1)-v(i,j))**2)+((v(i-1,j)-v(i,j))**2)+((v(i+1,j)-
     :v(i,j))**2)+((v(i-1,j+1)-v(i,j))**2)+((v(i,j+1)-v(i,j))**2)+
     :((v(i+1,j-1)-v(i,j))**2))/8.0
         ENDDO
      ENDDO
      
      DO i=2,mm-1 
         var(i,nn)=(((v(i-1,nn)-v(i,nn))**2)+((v(i-1,nn-1)-
     :v(i,nn))**2)+((v(i,nn-1)-v(i,nn))**2)+((v(i+1,nn-1)-
     :v(i,nn))**2)+((v(i+1,nn)-v(i,nn))**2))/5.0

         var(i,1)=(((v(i-1,1)-v(i,1))**2)+((v(i-1,2)-v(i,1))**2)+
     :    ((v(i,2)-v(i,1))**2)+((v(i+1,2)-v(i,1))**2)+((v(i+1,1)-
     :    v(i,1))**2))/5.0
      ENDDO

      DO j=2,nn-1 
         var(1,j)=(((v(1,j-1)-v(1,j))**2)+((v(2,j-1)-v(1,j))**2)+
     :    ((v(2,j)-v(1,j))**2)+((v(2,j+1)-v(1,j))**2)+((v(1,j+1)-
     :    v(1,j))**2))/5.0

         var(mm,j)=(((v(mm,j-1)-v(mm,j))**2)+((v(mm-1,j-1)-
     :    v(mm,j))**2)+((v(mm-1,j)-v(mm,j))**2)+((v(mm-1,j+1)-
     :    v(mm,j))**2)+((v(mm,j+1)-v(mm,j))**2))/5.0
      ENDDO
    
C now do the corners - what a pain
      var(1,1)=(((v(2,1)-v(1,1))**2)+((v(1,2)-v(1,1))**2)+
     :((v(2,2)-v(1,1))**2))/3.0
      var(mm,1)=(((v(mm-1,1)-v(mm,1))**2)+((v(1,2)-v(mm,1))**2)+
     :((v(mm-1,2)-v(mm,1))**2))/3.0
      var(1,nn)=(((v(2,nn)-v(1,nn))**2)+((v(1,nn-1)-v(1,nn))**2)+
     :((v(2,nn-1)-v(1,nn))**2))/3.0
      var(mm,nn)=(((v(mm-1,nn)-v(mm,nn))**2)+((v(mm,nn-1)-
     :v(mm,nn))**2)+((v(mm-1,nn-1)-v(mm,nn))**2))/3.0

C create the mask, and prepare v, vel for rotated calc
      
      DO i=1,mm
         DO j=1,nn
            IF (var(i,j).LT.mv2) THEN
               mask1(i,j)=1
            ELSE
               mask1(i,j)=0
            ENDIF
            vel(i,j)=v(i,j)+15.0
            IF (vel(i,j).GT.15) THEN
               vel(i,j)=vel(i,j)-30
            ENDIF
         ENDDO
      ENDDO

C work out the variance matrix for the rotated v

      DO i=2,mm-1
         DO j=2,nn-1
            var(i,j)=(((vel(i,j-1)-vel(i,j))**2)+((vel(i,j-1)-vel(i,j)
     $           )**2)+((vel(i+1,j-1)-vel(i,j))**2)+((vel(i-1,j)-vel(i
     $           ,j))**2)+((vel(i+1,j)-vel(i,j))**2)+((vel(i-1,j+1)
     $           -vel(i,j))**2)+((vel(i,j+1)-vel(i,j))**2)+((vel(i+1,j
     $           -1)-vel(i,j))**2))/8.0
         ENDDO
      ENDDO
      
      DO i=2,mm-1 
         var(i,nn)=(((vel(i-1,nn)-vel(i,nn))**2)+((vel(i-1,nn-1)-
     :vel(i,nn))**2)+((vel(i,nn-1)-vel(i,nn))**2)+((vel(i+1,nn-1)-
     :vel(i,nn))**2)+((vel(i+1,nn)-vel(i,nn))**2))/5.0

         var(i,1)=(((vel(i-1,1)-vel(i,1))**2)+((vel(i-1,2)-vel(i,1))
     $        **2)+((vel(i,2)-vel(i,1))**2)+ ((vel(i+1,2)-vel(i,1))**2
     $        )+((vel(i+1,1)-vel(i,1))**2))/5.0
      ENDDO

      DO j=2,nn-1 
         var(1,j)=(((vel(1,j-1)-vel(1,j))**2)+ 
     :        ((vel(2,j-1)-vel(1,j))**2)+
     :        ((vel(2,j)-vel(1,j))**2)+((vel(2,j+1)-vel(1,j))**2)
     :        +((vel(1,j+1)-vel(1,j))**2))/5.0

         var(mm,j)=(((vel(mm,j-1)-vel(mm,j))**2)+((vel(mm-1,j-1)-
     :    vel(mm,j))**2)+((vel(mm-1,j)-vel(mm,j))**2)+((vel(mm-1,j+1)-
     :    vel(mm,j))**2)+((vel(mm,j+1)-vel(mm,j))**2))/5.0
      ENDDO
   
C now do the corners - what a pain
      var(1,1)=(((vel(2,1)-vel(1,1))**2)+((vel(1,2)-vel(1,1))**2)+
     :((vel(2,2)-vel(1,1))**2))/3.0
      var(mm,1)=(((vel(mm-1,1)-vel(mm,1))**2)
     : +((vel(1,2)-vel(mm,1))**2)+((vel(mm-1,2)-vel(mm,1))**2))/3.0
      var(1,nn)=(((vel(2,nn)-vel(1,nn))**2)+ 
     :((vel(1,nn-1)-vel(1,nn))**2)+((vel(2,nn-1)-vel(1,nn))**2))/3.0
      var(mm,nn)=(((vel(mm-1,nn)-vel(mm,nn))**2)+((vel(mm,nn-1)-
     :vel(mm,nn))**2)+((vel(mm-1,nn-1)-vel(mm,nn))**2))/3.0

C create the second mask, and create composite, requiring
C discontinuity in both velocity fields
      
      DO i=1,mm
         DO j=1,nn
            vel(i,j)=nan
            IF ((var(i,j).LT.mv2).OR.(mask1(i,j).EQ.1)) THEN
               vel(i,j)=v(i,j)
            ENDIF
         ENDDO
      ENDDO

C check for lonely points in data sparse regions
      DO i=2,mm-1
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN
     :           (vel(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j
     $           +1))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))
     $           +mexIsNaN(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))
     $           +mexIsNaN(vel(i-1,j-1))).GT.lonely1))
         ENDDO
      ENDDO

      i=1
      k=mm
      DO j=2,nn-1
         mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :(i,j+1))+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN
     :(vel(i+1,j-1))+mexIsNaN(vel(i,j-1))).GT.(lonely1*5/8)))
         mask1(k,j)=((mexIsNaN(vel(k,j)).EQ.0).AND.((mexIsNaN(vel
     :(k-1,j))+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))+mexIsNaN
     :(vel(k,j-1))+mexIsNaN(vel(k-1,j-1))).GT.(lonely1*5/8)))
      ENDDO

      j=1
      k=nn
      DO i=2,mm-1
         mask1(i,j)=((mexIsNaN(vel(i,j)).EQ.0).AND.((mexIsNaN(vel
     :(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN
     :(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))).GT.(lonely1*5/8)))
         mask1(i,k)=((mexIsNaN(vel(i,k)).EQ.0).AND.((mexIsNaN(vel
     :(i-1,k))+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))+mexIsNaN
     :(vel(i,k-1))+mexIsNaN(vel(i-1,k-1))).GT.(lonely1*5/8)))
      ENDDO

      DO i=1,mm
         DO j=1,nn
            IF (mask1(i,j).EQ.1) THEN
               vel(i,j)=nan
            ENDIF
         ENDDO
      ENDDO

      DO i=2,mm-1
         DO j=2,nn-1
            mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel
     :(i-1,j))+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN
     :(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN(vel(i+1,j-1))+
     :mexIsNaN(vel(i,j-1))+mexIsNaN(vel(i-1,j-1))).LT.lonely2))
         ENDDO
      ENDDO

      i=1
      k=mm
      DO j=2,nn-1
         mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i,j+1))
     :+mexIsNaN(vel(i+1,j+1))+mexIsNaN(vel(i+1,j))+mexIsNaN(vel
     :(i+1,j-1))+mexIsNaN(vel(i,j-1))).LT.(lonely2*5/8)))
         mask1(k,j)=((mexIsNaN(vel(k,j))).AND.((mexIsNaN(vel(k-1,j))
     :+mexIsNaN(vel(k-1,j+1))+mexIsNaN(vel(k,j+1))+mexIsNaN(vel
     :(k,j-1))+mexIsNaN(vel(k-1,j-1))).LT.(lonely2*5/8)))
      ENDDO

      k=nn
      j=1
      DO i=2,mm-1
         mask1(i,j)=((mexIsNaN(vel(i,j))).AND.((mexIsNaN(vel(i-1,j))
     :+mexIsNaN(vel(i-1,j+1))+mexIsNaN(vel(i,j+1))+mexIsNaN(vel
     :(i+1,j+1))+mexIsNaN(vel(i+1,j))).LT.(lonely2*5/8)))
         mask1(i,k)=((mexIsNaN(vel(i,k))).AND.((mexIsNaN(vel(i-1,k))
     :+mexIsNaN(vel(i+1,k))+mexIsNaN(vel(i+1,k-1))+mexIsNaN(vel
     :(i,k-1))+mexIsNaN(vel(i-1,k-1))).LT.(lonely2*5/8)))
      ENDDO

      DO i=1,mm
         DO j=1,nn
            IF (mask1(i,j).EQ.1) THEN
               vel(i,j)=nan
            ENDIF
         ENDDO
      ENDDO


      return
      end
      

C=========================================================
C     fills in regions of NaNs                            
C=========================================================
      subroutine replace(vel,mm,nn)
      IMPLICIT NONE

      integer*4 mm, nn, M, N
      integer*4 i, j,k, count,ii,jj

      PARAMETER (M=400, N=1600)
      real*8 vel(mm,nn), v(M, N)
      integer*4 stacki(M*N), stackj(M*N),stackindex,stacki2(M*N),
     $     stackj2(M*N),stackcount,stacksize
      real*8 nan
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

C     Find all the points which are on the edge of regions - we only
c     want to spread out from these

      stackindex=0
      do i=2,mm-1
         do j=2,nn-1
            v(i,j)=vel(i,j)
            if (mexisnan(vel(i,j)).eq.0) then
               k=(mexisnan(vel(i-1,j+1)).eq.1)+(mexisnan(vel(i,j+1))
     $              .eq.1)+(mexisnan(vel(i+1,j+1)).eq.1)
     $              +(mexisnan(vel(i-1,j)).eq.1)+(mexisnan(vel(i+1,j))
     $              .eq.1)+(mexisnan(vel(i-1,j-1)).eq.1)
     $              +(mexisnan(vel(i,j-1)).eq.1)+(mexisnan(vel(i+1,j-1
     $              )).eq.1)
               if (k.gt.0) then
                  stackindex=stackindex+1
                  stacki(stackindex)=i
                  stackj(stackindex)=j
               endif
            endif
         enddo
      enddo
      stacksize=stackindex

      count=stacksize
      do while (count.gt.0)
C      do k=1,2
         stackcount=0
         do stackindex=1,count
            i=stacki(stackindex)
            j=stackj(stackindex)
            if ((i.gt.1).and.(i.lt.mm).and.(j.gt.1).and.(j.lt.nn))
     $           then  
               
               ii=i-1
               jj=j+1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i
               jj=j+1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i-1
               jj=j+1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i+1
               jj=j+1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i-1
               jj=j+1
               if (mexisnan(v(ii,jj)).eq.1) then
                   v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i-1
               jj=j
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i+1
               jj=j
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i-1
               jj=j-1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i
               jj=j-1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               ii=i+1
               jj=j-1
               if (mexisnan(v(ii,jj)).eq.1) then
                  v(ii,jj)=vel(i,j)
                  stackcount=stackcount+1
                  stacki2(stackcount)=ii
                  stackj2(stackcount)=jj
               endif
               
            endif
         enddo
         
         count=stackcount
         if (count.gt.0) then
            do k=1,count
               i=stacki2(k)
               j=stackj2(k)
               vel(i,j)=v(i,j)
               stacki(k)=stacki2(k)
               stackj(k)=stackj2(k)
            enddo
         endif
         
      enddo                     ! end of while count...

C Now do the edges
      do i=1,mm
         vel(i,1)=vel(i,2)
         vel(i,nn)=vel(i,nn-1)
      enddo

      do j=1,nn
         vel(1,j)=vel(2,j)
         vel(mm,j)=vel(mm-1,j)
      enddo

      count=0
      do i=1,mm
         do j=1,nn
            count=count+mexisnan(vel(i,j))
         enddo
      enddo

      if (count.ne.0) then
         print*,'replace hasnt worked properly...'
         print*, count,'nans found'
         print*,'Calling replace2...'
         CALL replace2(vel,mm,nn)
      endif


      return
      end

C=============================================================
C     fills in regions of NaNs (if the above hasn't worked?!) 
C=============================================================
      subroutine replace2(vel,mm,nn)
      IMPLICIT NONE

      integer*4 mm, nn, M, N
      integer*4 i, j,k, count

      PARAMETER (M=400, N=1600)
      real*8 vel(mm,nn), v(M, N)

      real*8 nan
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      do i=1,mm
         do j=1,nn
            v(i,j)=vel(i,j)
         enddo
      enddo

      k=0
      count=1
      do while (count.gt.0)
C      do k=1,2

         do i=2,mm-1
            do j=2,nn-1
               if (mexisnan(vel(i,j)).eq.0) then  
                  
                  if (mexisnan(vel(i-1,j+1)).eq.1) then
                     v(i-1,j+1)=vel(i,j)
                  endif
                  if (mexisnan(vel(i,j+1)).eq.1) then
                     v(i,j+1)=vel(i,j)
                  endif
                  if (mexisnan(vel(i+1,j+1)).eq.1) then
                     v(i+1,j+1)=vel(i,j)
                  endif
                  if (mexisnan(vel(i-1,j)).eq.1) then
                     v(i-1,j)=vel(i,j)
                  endif
                  if (mexisnan(vel(i+1,j)).eq.1) then
                     v(i+1,j)=vel(i,j)
                  endif
                  if (mexisnan(vel(i-1,j-1)).eq.1) then
                     v(i-1,j-1)=vel(i,j)
                  endif
                  if (mexisnan(vel(i,j-1)).eq.1) then
                     v(i,j-1)=vel(i,j)
                  endif
                  if (mexisnan(vel(i+1,j-1)).eq.1) then
                     v(i+1,j-1)=vel(i,j)
                  endif
                  
               endif
            enddo
         enddo
         
         count=0
         do i=2,mm-1
            do j=2,nn-1
               vel(i,j)=v(i,j)
               count=count+mexisnan(vel(i,j))
            enddo
         enddo
         print*, count, ((mm-2)*(nn-2))
         if (count.eq.((mm-2)*(nn-2))) then
            count=-1
         endif
         k=k+1
      enddo                     ! end of while count...

      if (count.eq.-1) then
         print*, 'Input field is all NaNs'
C         do i=1,mm
C            do j=1,nn
C               vel(i,j)=nan
C            enddo
C         enddo
      endif

      return
      end


C=========================================================
C     Gets rid of small regions of data...                           
C=========================================================
      subroutine reduce(vel,size,mm,nn)
      IMPLICIT NONE

      integer*4 mm, nn, M, N, size, total
      integer*4 i, j,ii,jj

      PARAMETER (M=400, N=1600)
      real*8 vel(mm,nn)
      real*8 nan
      
      integer*4 mexIsNaN
      real mexGetNaN
      external mexGetNaN, mexIsNaN
      nan=mexGetNan()

      do i=1,mm-size,2
         do j=1,nn-size,2
            
            total=0
            do ii=0,size
               jj=0
               total=total+mexisnan(vel(i+ii,j+jj))
               jj=size
               total=total+mexisnan(vel(i+ii,j+jj))
            enddo
            do jj=1,size-1
               ii=0
               total=total+mexisnan(vel(i+ii,j+jj))
               ii=size
               total=total+mexisnan(vel(i+ii,j+jj))
            enddo

            if (total.eq.(size*4)) then ! ie if NaNs all around
               do ii=i,i+size
                  do jj=j,j+size
                     vel(ii,jj)=nan
                  enddo
               enddo
            endif

         enddo
      enddo

      return
      end




