el=5;
rmin=11;
rmax=20;

plot([rmin rmax].*cos(el*pi/180),[rmin rmax].*sin(el*pi/180),'k');

%C=0.67; %for lateral variations (kennedy75)
C=0.5;  %for longitudinal variations (kennedy75)

%set up variables for calculating the averaged spectrum
power_av=[];
count=0;
param2=[1e-3 -5/3]; % Initial conditions [epsilon power]
param1=[0 0 0 0 0];
outer_k=1e-3;

figure(61);clf

%for raster=33:50
for raster=71:71

	if [1]

		%	raster=35;
		scan=1;

		% 6197 UTLS/DCFZ case 3: 16 Jan 1999 0334-0515
		filen='/home/mm0800/chapmand/data/radar/6197dop'; 
		filenz='/home/mm0800/chapmand/data/radar/6197new'; 
		sumfile=[filen '.sum'];
		fname=[filen '.dat'];
		fnamez=[filenz '.dat'];
		
		dfilen='data.mat';
		cscdir='/home/mm0800/chapmand/matlab/spectra/';
		filename=fname;
		
		extract
		
		cd /home/mm0800/chapmand/matlab/spectra
		load([cscdir 'data.mat'])
		
		[mm nn]=size(v2);

		elev=elev-mean(diff(elev));
		
		angles=elev(1:nn)';
		X=range'*cos(angles'*pi/180);
		Z=range'*sin(angles'*pi/180);
		Z=Z+3*X.^2/(8*6371);

		% Taken from rhiplot........
		danplot_vars
		
		vmin=vminrhi;
		vf=30;
		vmax=vmin+vf;
		vu=v2;

		%unfold and zap
		disp('unfolding...');
		%	vu=munfold(vu);
		[vu region]=munfill(vu);
		disp(' and zapping...')
		vu=mzap(vu,zapparams(1),zapparams(2),zapparams(3));
		index=find(isnan(vu)==0);
		vu=vu-30.0*floor(mean(mean(vu(index)+15))/30.0);
		%vu=vu+30;
		vu2=mzap(vu,4,3,0);
		vmin=min(min(vu2));
		vmax=max(max(vu2));
		
		%	figure(40); pcolor(elev,range,vu);shading flat ; colorbar ; zoom on
		
	end

	%===============Main spectral bit==================

	clear pi;

	eli=find(abs(elev-el) == min(abs(elev-el)));
	rmini=find(abs(range-rmin) == min(abs(range-rmin)));
	rmaxi=find(abs(range-rmax) == min(abs(range-rmax)));

	sig=vu(rmini:rmaxi,eli);
	ra=range(rmini:rmaxi);

	i=find(~isnan(sig));
	ra0=ra(i);
	sig0=sig(i);


	res0=sig0';

	%try detrending data this way...
	
	res0=res0-(res0(1));
	res0=res0-(res0(end).*(0:length(res0)-1)/(length(res0)-1));

	%and interpoate carefully, to get rid of NaNs at the beginning and end

	res=interp1([ra0(end)-(ra(end)-ra(1)) ra0(2:end-1) ra(1)+ ...
							 (ra(end)-ra(1))], [res0(end) res0(2:end-1) res0(1)],ra);

	%need to detrend the data...
	%	fit=polyfit([1:length(res)],res,1);res=res-[1:length(res)]*fit(1)-fit(2);

	
%	res=[res(1:end-1) fliplr(res)];
%	ra=[ra(1:end-1) ra+(max(ra)-min(ra))];
	
	% Now we have the residual, res, on the same 1D grid as azim

	rest=fft(res);
	n=length(rest);
	rest(1)=[];
	dl=mean(diff(ra))*1000;
	nyquist=(1/dl)/2;
	k= ((1:n/2)/(n/2))*nyquist;
%	power=(abs(rest(1:n/2)).^2)./k;
	
% see page 72 of Doviak and Zrnic
	S=(rest(1:n/2)).*conj(rest(1:n/2))*dl/length(res);
	power=S;

	figure(60);clf;plot(ra,res), grid on;drawnow
	figure(61);hold on;plot(ra,res), grid on;drawnow
	
	if length(power_av)>0
		power_av=power_av+power;
	else
		power_av=power;
	end
	count=count+1;

	if [1]

		%fit a power law to to small end of the spectrum
		
		global k power istart C
		istart=max(find(k <= outer_k));
		
		%epsilon=10e-3;
		
		opts=foptions;opts(14)=4000;
		param2=fmins('powerfun',param2,opts);
		epsilon=param2(1);
		pow=param2(2);
		
		klaw=k(istart:end);
		powerlaw=C*(epsilon^(2/3))*(klaw.^(pow));
	end

	figure(count)
	clf
	drawnow
	set(gcf,'position',[50+count*25, 30, 560, 420]);
	loglog(k,power), grid on
	xlabel('k (cycles m^{-1})');ylabel('Power (m^3s^{-2})');
	hold on
	if [1]
		plot(klaw,powerlaw,'r');
		title([' Best fit for Power Law = ' num2str(pow)])
	end
	drawnow

end

% Now we've finished doing the individual spectra....
% Time to do the average

power_av=power_av./count;

figure(50);

power=power_av;
clf
loglog(k,power), grid on
xlabel('k (cycles m^{-1})');ylabel('Averaged Power (m^3s^{-2})');

%fit a power law to to small end of the spectrum

global k power istart C
istart=max(find(k <= outer_k));

%epsilon=10e-3;

opts=foptions;opts(14)=4000;
param2=fmins('powerfun',param2,opts);
epsilon=param2(1);
pow=param2(2);

klaw=k(istart:end);
powerlaw=C*(epsilon^(2/3))*(klaw.^(pow));
hold on
plot(klaw,powerlaw,'r');

%Now do best fit with just -5/3 law
opts=foptions;
epsilon=1e-3;
epsilon=fmins('powerfun2',epsilon,opts);

klaw=k(istart:end);
powerlaw=C*(epsilon^(2/3))*(klaw.^(-5/3));
hold on
plot(klaw,powerlaw,'k');

title(['Averaged \epsilon (-5/3 law, black line) = ' num2str(epsilon*1000) ...
			 ' \times 10^{-3} m^2 s^{-3}. Best fit power law= ' num2str(pow)])








